/* tr_delete - delete the node **pln from tree *plt
 */
#include "tree.h"
void tr_delete(plt, pln, cmpfn)
	TR_NODE **plt;			/* ptr to link-in of tree */
	TR_NODE **pln;			/* ptr to link-in of node */
	int (*cmpfn)();			/* ptr to comparison function */
	{
	TR_NODE *pn;			/* ptr to specific node of tree */
	TR_NODE *ps;			/* ptr to node's successor */
	TR_NODE **pls;			/* ptr to link-in of successor */

	pn = *pln;					/* pn pts to the node to delete */
	if (pn->right == NULL)		/* if node has no right subtree, */
		{
		if (pn->left == NULL)	/* if node has no children, */
			*pln = NULL;		/* replacement for pn is NULL */
		else					/* if node has L subtree, but not R, */
			*pln = pn->left;	/* replacement is pn's L subtree */
		}
	else if (pn->left == NULL)	/* if node has R subtree, but not L */
		*pln = pn->right;		/* replacement is pn's R subtree */
	else						/* if node has R and L subtrees *
		{
		pls = TR_LNEXT(plt, pn, cmpfn);	/* get ptr to link-in of succ */
		ps = *pls;				/* ps now points to successor */
		*pls = ps->right;		/* succ's R subtree takes succ's place */
		ps->right = pn->right;	/* succ acquires node's R ... */
		ps->left = pn->left;	/* ... and L subtree */
		*pln = ps;				/* replacement is successor */
		}
	free(pn);
	}
